uIP 1.0: uIP Address Resolution Protocol

- Main Page
- Modules
- Data Structures
- Files
- Examples

# uIP Address Resolution Protocol
[The uIP TCP/IP stack]

## Detailed Description

The Address Resolution Protocol ARP is used for mapping between IP addresses and link level addresses such as the Ethernet MAC addresses.

ARP uses broadcast queries to ask for the link level address of a known IP address and the host which is configured with the IP address for which the query was meant, will respond with its link level address.

Note:
  This ARP implementation only supports Ethernet.

## Files

file | uip_arp.h
| Macros and definitions for the ARP module.

file | uip_arp.c
| Implementation of the ARP Address Resolution Protocol.

## Data Structures

struct | uip_eth_hdr
| The Ethernet header. More...

## Defines

#define | UIP_ETHTYPE_ARP 0x0806
#define | UIP_ETHTYPE_IP 0x0800
#define | UIP_ETHTYPE_IP6 0x86dd
#define | uip_arp_ipin()
#define | ARP_REQUEST 1
#define | ARP_REPLY 2
#define | ARP_HWTYPE_ETH 1
#define | BUF ((struct arp_hdr *)&uip_buf[0])
#define | IPBUF ((struct ethip_hdr *)&uip_buf[0])

## Functions

void | uip_arp_init (void)
| Initialize the ARP module.
void | uip_arp_arpin (void)
| ARP processing for incoming ARP packets.
void | uip_arp_out (void)
| Prepend Ethernet header to an outbound IP packet and see if we need to send out an ARP request.
void | uip_arp_timer (void)
| Periodic ARP processing function.

## Variables

uip_eth_addr | uip_ethaddr

## Function Documentation

void uip_arp_arpin | ( | void |  | ) |

ARP processing for incoming ARP packets.

This function should be called by the device driver when an ARP packet has been received. The function will act differently depending on the ARP packet type: if it is a reply for a request that we previously sent out, the ARP cache will be filled in with the values from the ARP reply. If the incoming ARP packet is an ARP request for our IP address, an ARP reply packet is created and put into the uip_buf[] buffer.

When the function returns, the value of the global variable uip_len indicates whether the device driver should send out a packet or not. If uip_len is zero, no packet should be sent. If uip_len is non-zero, it contains the length of the outbound packet that is present in the uip_buf[] buffer.

This function expects an ARP packet with a prepended Ethernet header in the uip_buf[] buffer, and the length of the packet in the global variable uip_len.

Examples:
  example-mainloop-with-arp.c.

Definition at line 278 of file uip_arp.c.

References uip_eth_addr::addr, ARP_REPLY, ARP_REQUEST, BUF, HTONS, uip_ethaddr, UIP_ETHTYPE_ARP, uip_hostaddr, uip_ipaddr_cmp, and uip_len.

void uip_arp_out | ( | void |  | ) |

Prepend Ethernet header to an outbound IP packet and see if we need to send out an ARP request.

This function should be called before sending out an IP packet. The function checks the destination IP address of the IP packet to see what Ethernet MAC address that should be used as a destination MAC address on the Ethernet.

If the destination IP address is in the local network (determined by logical ANDing of netmask and our IP address), the function checks the ARP cache to see if an entry for the destination IP address is found. If so, an Ethernet header is prepended and the function returns. If no ARP cache entry is found for the destination IP address, the packet in the uip_buf[] is replaced by an ARP request packet for the IP address. The IP packet is dropped and it is assumed that they higher level protocols (e.g., TCP) eventually will retransmit the dropped packet.

If the destination IP address is not on the local network, the IP address of the default router is used instead.

When the function returns, a packet is present in the uip_buf[] buffer, and the length of the packet is in the global variable uip_len.

Examples:
  example-mainloop-with-arp.c.

Definition at line 354 of file uip_arp.c.

References uip_eth_addr::addr, IPBUF, UIP_ARPTAB_SIZE, uip_draddr, uip_hostaddr, uip_ipaddr_cmp, uip_ipaddr_copy, and uip_ipaddr_maskcmp.

void uip_arp_timer | ( | void |  | ) |

Periodic ARP processing function.

This function performs periodic timer processing in the ARP module and should be called at regular intervals. The recommended interval is 10 seconds between the calls.

Examples:
  example-mainloop-with-arp.c.

Definition at line 142 of file uip_arp.c.

References UIP_ARP_MAXAGE, and UIP_ARPTAB_SIZE.